(load-option 'format)
;;; stt.scm contains a reader that translates strings into lists of
;;; symbols and a translator that translates transparent specifications
;;; for semantic transition trees into not-particularly-transparent,
;;; deeply-nested Scheme programs
(load "/mit/6.034/ps4/stt.scm")

;;; grammar.scm contains a basic grammar, in the form of semantic 
;;; transition trees, that translates questions into calls to relational
;;; database procedures.
(load "/mit/6.034/ps4/grammar.scm")

;;; rdb.scm contains a relational database stub; that is, it contains 
;;; procedures -- such as db-select and db-project -- that mimic those 
;;; of a relational database system
(load "/mit/6.034/ps4/rdb.scm")

;;; blocks.scm contains a database describing some blocks
(load "/mit/6.034/ps4/blocks.scm")


;;; rugs.scm contains a database describing an oriental rug inventory 
(load "/mit/6.034/ps4/rugs.scm")

;;; frames.scm contains a database describing an oriental rug inventory,
;;; but this time expressed in terms of a 6.001-style frame system, rather 
;;; than in terms of a relational database stub.
;;;
;;; this will overwrite the rugs database, so don't load it until you're 
;;; ready to work with the frames version
;(load "/mit/6.034/ps4/frames.scm")




