(define (time-run thunk)
  (let* ((start-time (real-time-clock))
	 (result (thunk))
	 (end-time (real-time-clock)))
    (format #t "~%Elapsed time: ~a"
	    (elapsed-time-string (- end-time start-time)))
    result))

(define (elapsed-time-string elapsed-time-in-ticks)
  (let* ((elapsed-time (internal-time/ticks->seconds elapsed-time-in-ticks))
	 (hours (integer-truncate (truncate->exact elapsed-time) (* 60 60)))
	 (minutes (integer-truncate
		   (- (truncate->exact elapsed-time) (* hours 60 60))
		   60))
	 (seconds (- elapsed-time (* hours 60 60) (* minutes 60))))
    (define (format-filling-tens n)
      (format #f (if (< n 10) "0~a" "~a") n))
    (format #f "~a:~a:~a"
	    (format-filling-tens hours)
	    (format-filling-tens minutes)
	    (format-filling-tens seconds))))

;; this string is final value so it will be shown when loading this file
;; to remind how to use it.
"example:  (time-run (lambda () (TEST-PROGRAM)))"

