;;;; -*- mode:Scheme -*- ;;;;

;;;; REMARKS

#|

Solves linear equations by row reduction.  
Doubtlessly has terrible numeric properties.

|#

;;;; USER-LEVEL PROCEDURE

(define (solve-equations rows)
  "
  Purpose:	Solve linear equations.
  Arguments:	Rows, in the following form:
		((c11 c12 c13 c1)
		 (c21 c22 c23 c2)
		 (c31 c32 c33 c3))
		where
		  c11 x + c12 y + c13 z = c1
		  c21 x + c22 y + c23 z = c2
		  c31 x + c32 y + c33 z = c3
  Returns:	(x y z)
  "
  (let ((solution ()))
    (set! rows (map (lambda (e) (append e ())) rows))
    (do ((n 0 (1+ n)))
	((= n (length rows)))
      (set-car! (list-tail rows n)
	    (scale-row (/ (list-ref (list-ref rows n) n))
		       (list-ref rows n)))
      (do ((m 0 (1+ m)))
	  ((= m (length rows)))
	(if (not (= m n))
	    (set-car! (list-tail rows m)
		      (add-two-rows
		       (list-ref rows m)
		       (scale-row (- (list-ref (list-ref rows m) n))
					       (list-ref rows n)))))))
    (set! solution (append-map last-pair rows))
    solution))

;;;; AUXILIARIES

(define (add-two-rows r1 r2) (map + r1 r2))

(define (scale-row c r) (map (lambda (e) (* c e)) r))

